(function(){
var _verbose = false;

var c2Runtime;

var step = -1;
var started = false;
var audioBuffer = [];
var timerUpdate;


var listOfAllSong = ["321.ogg","3210.ogg","ally_buildloop.ogg","ally_buildweaponloop.ogg","ally_changegun.ogg","ally_object_mineexplosion.ogg","ally_object_new_barbed.ogg","ally_object_new_boulder.ogg","ally_object_new_metalplaque.ogg","ally_object_new_mine.ogg","ally_object_new_sandbag.ogg","ally_object_new_turet.ogg","ally_object_new_turet_shot.ogg","ally_object_new_whoosh.ogg","ally_sidechange.ogg","butt_level.ogg","butt_menu.ogg","deathearthquake.ogg","defeat.ogg","enemy_attack_bomb.ogg","enemy_attack_chainsaw.ogg","enemy_attack_punch.ogg","enemy_attack_sandbag.ogg","enemy_attack_scratch.ogg","enemy_hit.ogg","enemy_hitexplosion.ogg","gun_ak47.ogg","gun_bazooka.ogg","gun_flamev2.ogg","gun_flamev2_loop.ogg","gun_handgunv2.ogg","gun_machinegunv2.ogg","gun_rocket.ogg","gun_shotgun.ogg","gun_sniper.ogg","headshot.ogg","helico.ogg","hud_openmenu.ogg","hud_roolmenubip.ogg","jackpot.ogg","moderage.ogg","moderage_end.ogg","music_ingame.ogg","music_menu.ogg","newrecord.ogg","no_money.ogg","revival.ogg","sfx_billy_the_kid_cible_shoot_0.ogg","sfx_billy_the_kid_cible_shoot_1.ogg","sfx_billy_the_kid_cible_shoot_10.ogg","sfx_billy_the_kid_cible_shoot_2.ogg","sfx_billy_the_kid_cible_shoot_3.ogg","sfx_billy_the_kid_cible_shoot_4.ogg","sfx_billy_the_kid_cible_shoot_5.ogg","sfx_billy_the_kid_cible_shoot_6.ogg","sfx_billy_the_kid_cible_shoot_7.ogg","sfx_billy_the_kid_cible_shoot_8.ogg","sfx_billy_the_kid_cible_shoot_9.ogg","shop_upgrade.ogg","splash_ally.ogg","splash_title.ogg","splash_zombies.ogg","start.ogg","star_clickon.ogg","victory_coin.ogg","victory_star.ogg","vitory_yeah.ogg","wrong.ogg"];
var category_list = [];

fillArrayCategory();

eventToFire.registerEvent("c2LayoutChange",
	function (args){
		if(!started){
			c2Runtime = cr_getC2Runtime();
			started = true;
			nextStep();
		}
	}
);

function update(){
	for (var i = 0; i < audioBuffer.length; i++) {
		if(audioBuffer[i].isLoadedAndDecoded()){ //audioBuffer[i].isLoaded()
			if(_verbose) console.log("sound end load & decoded:",audioBuffer[i].src);
			audioBuffer.splice(i, 1);
		}
	};

	if(audioBuffer.length == 0){
		nextStep();
	}
}

function nextStep(){
	step +=1;
	clearInterval(timerUpdate);

	if(category_list[step]){
		for (var i = category_list[step].length - 1; i >= 0; i--) {
			if(_verbose) console.log("sound start load:",category_list[step][i]);
			audioBuffer.push(c2Runtime.audioInstance.getAudioBuffer(c2Runtime.files_subfolder+category_list[step][i]));
		};

		timerUpdate = setInterval(update,100);

	}else{
		if(_verbose) console.log("all Sound loaded & decoded");
	}
}

function fillArrayCategory(){
	var firstLoad = [];
	var arrayWihtoutMusic = [];
	var musicInGame = [];
	var musicGameOver = [];
	var name;

	for (var i = 0; i < listOfAllSong.length; i++) {
		name = listOfAllSong[i].replace(/\.[a-z]+/,"");
		
		if(name == "butt_level" || name == "butt_menu" || name == "music_menu"){
			firstLoad.push(listOfAllSong[i]);
		}
		else if(name == "music_ingame"){
			musicInGame.push(listOfAllSong[i]);
		}
		//list of gameOverSong
		else if(name == "music_game_over" || name == "defeat_sound" || name == "defeat" || name == "victory_game_over" || name == "looser" || name == "gameOver_defeat" || name == "gameOver"){
			musicGameOver.push(listOfAllSong[i]);
		}
		else {
			arrayWihtoutMusic.push(listOfAllSong[i]);
		}
	};
	category_list.push(firstLoad);
	category_list.push(arrayWihtoutMusic);
	category_list.push(musicInGame);
	category_list.push(musicGameOver);
}

}())

